/*

	(c) Shopping-ManaJer develoment-team
	This Code is published unter the Gnu-GPL v2

	Modified for JippySnake7
*/

import java.awt.Canvas;
import java.awt.Color;
import javax.swing.JLabel;

class GUIUpdater {
	private Renderer renderer;
	private Renderer hudRenderer;
	private JSLevel level;
	private Snake snk;
	private Player player;
	private int type;
	private boolean reachedUltraSnake;
	private boolean drawPaused;
	private int[] playerLevelDone;
	
	//Needed Vars for drawing Hud
	private int applesYOffset; //2, if timerUsed, 0 else
	
	//Need to know where to draw new green apples
	private int drawApplesX;
	private int drawApplesY;
	private int curApples;
	
	private int menu;
	//-1: no menu
	//0: mainMenu
	//1: Menu "fresses"
	//.
	//.
	//.
	//6: stats
	private int mmx;
	
	int size = 25;
	int offSize = 5;
	int fak = 1;
	public GUIUpdater(Canvas c, Canvas ch, Player p, boolean hd) {
		player = p;
		reachedUltraSnake = false;
		drawPaused = false;
		playerLevelDone = new int[100];
		for (int i = 0; i < 100; i++) playerLevelDone[i] = -1;
		if (hd) {
			renderer = new Renderer(c, "res/textures-HD/texturesE");
			hudRenderer = new Renderer(ch, "res/textures-HD/texturesE");
			size = 50;
			fak = 2;
			offSize = 10;
		} else {
			renderer = new Renderer(c, "res/textures/texturesE");
			hudRenderer = new Renderer(ch, "res/textures/texturesE");
		}
	}
	
	public void setType(int t) {
		type = t;
	}

	public void setLevel(JSLevel l) {
		level = l;
		type = l.getType();
		prepareHud();
	}
	
	public void prepareHud() {
		//code for preparing hud here
		if (level.timerUsed()) applesYOffset = 2;
		else applesYOffset = 0;
		
		hudRenderer.drawRect(0,Color.BLACK,0,0,5*size,20*size);
		curApples = 0;
		//draw toDo Apples
		drawApplesX = 0;
		drawApplesY = applesYOffset;
		for (int i = 0; i < level.getMinApples(); i++) {
			hudRenderer.drawTexture(0, 902, (int) (drawApplesX*size/2.0), drawApplesY*((int) (size/2.0)));
			incPos();
		}
		//draw maxApples
		drawApplesX = 0;
		drawApplesY = applesYOffset;
		for (int i = 0; i < player.getLongestSnake(level.getType(), level.getLevelNum()); i++) {
			hudRenderer.drawTexture(0, 901, (int) (drawApplesX*size/2.0), drawApplesY*((int) (size/2.0)));
			incPos();
		}
		drawApplesX = 0;
		drawApplesY = applesYOffset;
		
		if (level.timerUsed()) {
			hudRenderer.drawRect(0, Color.GREEN, 0,0, 5*size,size);
			hudRenderer.drawTexture(0, 903, 0, 0);
		}
	}
	
	public void setSnake(Snake s) {
		snk = s;
	}
	
	public synchronized void draw(boolean paused, boolean makeBlind, Coord crd) {
		if (paused && drawPaused) {
			hudRenderer.flushScreen();
			renderer.flushScreen();
			return;
		}
		if (!paused && drawPaused) drawPaused = false;
		if (level.getNumApples() >= 250) {
			if (!reachedUltraSnake) {
				reachedUltraSnake = true;
				player.incrUltraSnakes();
				player.savePlayer();
			}
		}
		
		//Begin new Hud code
		if (level.getNumApples() > curApples) {
			curApples++;
			hudRenderer.drawTexture(0, 900, (int) (drawApplesX*size/2.0), drawApplesY*((int) (size/2.0)));
			incPos();
		}
		
		if (level.timerUsed()) {
			Color col;
			if (level.remainingTime() >= 180)
				col = new Color(510-((int) (level.remainingTime()*17/12)), 255, 0);
			else
				col = new Color(255, (int) (level.remainingTime()*17/12), 0);
			hudRenderer.drawRect(0,Color.BLACK,0,0,5*size,size);
			hudRenderer.drawRect(0,col,0,0,level.remainingTime()*size/72, size);
			hudRenderer.drawTexture(0,903,0,0);
		}
		//End new Hud code
		
		//renew all snake-layers:
		for (int i = 0; i < level.getNumLayers(); i++)
			renderer.reNewLayer(2*i+1);
		//drawSnake
		drawSnake();
		
		//finallay: render everything
		renderer.preRender();
		hudRenderer.preRender();
		if (makeBlind) {
			int Y = crd.getY();
			int X = crd.getX();
			int Z = crd.getZ();
			renderer.clearScreen(Color.BLACK, 0, 0,                          20*size, size*Y-4*size-offSize*Z);
			renderer.clearScreen(Color.BLACK, 0, size*Y+5*size-offSize*Z,    20*size, 20*size);
			renderer.clearScreen(Color.BLACK, 0, 0,                          size*X-4*size-offSize*Z, 20*size);
			renderer.clearScreen(Color.BLACK, size*X+5*size-offSize*Z, 0,    20*size, 20*size);
			renderer.drawTextureOnScreen(1100, size*X-4*size-offSize*Z, size*Y-4*size-offSize*Z);
		}
		if (paused) {
			if (menu == 0) {
				updateMenu(0, level.getType(), 0);
			} else if (menu < 6)
				updateMenu(0, level.getLevelNum()%10, (int) (level.getLevelNum()/10));
			drawPaused = true;
		}
		showGame();
		showHud();
	}
	
	private void drawMenu() {
		renderer.drawTextureOnScreen(1102+menu, 0, 0);
		if ((menu > 0) && (menu < 6)) drawLC();
		if (menu == 6) drawStats();
	}
	
	public void resetReachedUltraSnake() {
		reachedUltraSnake = false;
	}
	
	//draws the level
	public void drawLevel() {
		int X;
		int Y;
		int Z;
		
		renderer.reNewAllLayers();
		for (Coord crd : Coord.range(Coord.getZeroCoord(), level.getSize().add(new Coord(-1,-1,-1)))) {
			X = crd.getX();
			Y = crd.getY();
			Z = crd.getZ();
			renderer.drawTexture(0,level.getLayerDown(crd), size*X, size*Y);
			renderer.drawTexture(2*(Z+1),level.getLayer(crd), size*X-offSize*(Z+1), size*Y-offSize*(Z+1));
			renderer.drawTexture(2*level.getNumLayers()+1,level.getLayerTop(crd), size*X-offSize*(Z+1), size*Y-offSize*(Z+1));
		}
	}
	
	private void drawSnake() {
		int X;
		int Y;
		int Z;
		for (Coord crd : Coord.range(Coord.getZeroCoord(), level.getSize().add(new Coord(-1,-1,-1)))) {	
			X = crd.getX();
			Y = crd.getY();
			Z = crd.getZ();
			if (level.isAppleAt(crd)) renderer.drawTexture(2*Z+1,999,size*X-offSize*Z, size*Y-offSize*Z);
		}
			X = snk.getHeadPos().getX();
			Y = snk.getHeadPos().getY();
			Z = snk.getHeadPos().getZ();
		
		renderer.drawTexture(2*Z+1,snk.getHeadTexture(), size*X-offSize*Z, size*Y-offSize*Z);
		for (SnakeElement s: snk.getBodyElements()) {
			X = s.getPos().getX();
			Y = s.getPos().getY();
			Z = s.getPos().getZ();
			renderer.drawTexture(2*Z+1,s.getTexture(), size*X-offSize*Z, size*Y-offSize*Z);
		}
	}
	
	private void drawStats() {
		int count;
		int drawWidth;
		Color col;
		for (int i = 0; i < 5; i++) {
			count = 0;
			for (int j = 0; j < Globals.NUM_LEVELS[i]; j++) {
				if (player.getLevelDone(i,j) > 1) count++;
				drawWidth = (int) (24.0/5.0*count);
				if (i == 1) drawWidth /= 2;
				if (drawWidth > 120)
					col = new Color(510-((int) (drawWidth*17.0/8.0)), 255, 0);
				else
					col = new Color(255, (int) (drawWidth*17.0/8.0), 0);
				renderer.clearScreen(col, 155*fak, (int) (87.5*fak)+65*fak*i, drawWidth*fak, (int) (62.5*fak));
			}
		}
	}
	
	private void drawLC() {
		int t = menu-1;
		int maxY = 5;
		if (t == 1) maxY = 10;
		for (int x = 0; x < 10; x++) {
		for (int y = 0; y < maxY; y++) {
			renderer.drawTextureOnScreen(1200+player.getLevelDone(t,10*y+x), 150*fak+size*x, 150*fak+size*y);
		}
		}
	}
	
	public void updateMenu(int p, int x, int y) {
		renderer.preRender();
		Coord crd = snk.getHeadPos();
		if (level.getType()==4) {
			int Y = crd.getY();
			int X = crd.getX();
			int Z = crd.getZ();
			renderer.clearScreen(Color.BLACK, 0, 0,                          20*size, size*Y-4*size-offSize*Z);
			renderer.clearScreen(Color.BLACK, 0, size*Y+5*size-offSize*Z,    20*size, 20*size);
			renderer.clearScreen(Color.BLACK, 0, 0,                          size*X-4*size-offSize*Z, 20*size);
			renderer.clearScreen(Color.BLACK, size*X+5*size-offSize*Z, 0,    20*size, 20*size);
			renderer.drawTextureOnScreen(1100, size*X-4*size-offSize*Z, size*Y-4*size-offSize*Z);
		}

		drawMenu();
	//	System.out.println(p+"  "+x+"  "+y+"  "+menu);
		if (menu == 0) {
			if (p == 0) {
				renderer.drawTextureOnScreen(1110+x, (int) (187.5*fak),  (int) (208*fak));
				renderer.drawTextureOnScreen(1110+x, (int) (187.5*fak),  (int) (208*fak));
				renderer.drawTextureOnScreen(1120+(x+1)%5, (int) (337.5*fak),  (int) (208*fak));
				int tmp = (x-1);
				if (tmp < 0) tmp+=5;
				renderer.drawTextureOnScreen(1115+tmp, (int) (37.5*fak),  (int) (208*fak));
				/*if (x == 1) renderer.drawTextureOnScreen(1111, (int) (187.5*fak), (int) (137.5*fak));
				if (x == 2) renderer.drawTextureOnScreen(1112, (int) (337.5*fak), (int) (137.5*fak));
				if (x == 3) renderer.drawTextureOnScreen(1113, (int) (112.5*fak), (int) (287.5*fak));
				if (x == 4) renderer.drawTextureOnScreen(1114, (int) (262.5*fak), (int) (287.5*fak));
				*/
				mmx = x;
			}
			
			if (p == 1) {
				renderer.drawTextureOnScreen(1110+mmx, (int) (187.5*fak),  (int) (208*fak));
				if (x == 0) renderer.drawTextureOnScreen(1126, (int) (25.5*fak), (int) (424.5*fak));
				if (x == 1) renderer.drawTextureOnScreen(1125, (int) (412.5*fak), (int) (424.5*fak));
			}
		} else if (menu < 6) {
			if (p == 0)
				renderer.drawTextureOnScreen(1127,150*fak+size*x,150*fak+size*y);
			if (p == 1)
				renderer.drawTextureOnScreen(1125, (int) (412.5*fak), (int) (424.5*fak));
		} else if (menu == 6) {
				renderer.drawTextureOnScreen(1125, (int) (412.5*fak), (int) (424.5*fak));
		}

		showGame();
	}
	public void showGame() {
		renderer.flushScreen();
	}

	public void showHud() {
		hudRenderer.flushScreen();
	}
	
	public void setMenu(int m) {
		menu = m;
	}
	
	private void incPos() {
		drawApplesX++;
		if (drawApplesX == 10) {
			drawApplesX = 0;
			drawApplesY++;
		}
	}
}